/* Create database script for WARSVR on MySQL 
 * Tested with MySQL 3.23
 * Made by Jarle (jgaa) Aase february, 2003
 *
 * ********************************************************
 * CAUTION: WILL DETETE THE 'warsvr' DATABASE IF IT EXISTS!
 * ********************************************************
 */


DROP DATABASE IF EXISTS warsvr;
CREATE DATABASE warsvr;

use warsvr;

CREATE TABLE Session (
	ID int NOT NULL ,
	UserID binary (8) NOT NULL ,
	LoginTime datetime NOT NULL ,
	LogoutTime datetime NULL ,
	UserName varchar (128) NOT NULL ,
	FromDomain int NOT NULL ,
	FromDomainName char (128) NOT NULL ,
	ServerID binary (8) NULL ,
	ServerName char (32) NOT NULL ,
	SessionID binary (8) NULL,

	PRIMARY KEY(ID),
	KEY ix_login_time (LoginTime),
	KEY ix_logout_time (LogoutTime),
	KEY ix_user_name (UserName, LoginTime),
	KEY ix_server_name (ServerName, LoginTime),
	KEY ix_domain (FromDomain, LoginTime),
	KEY ix_domain_name (FromDomainName, LoginTime)
);

CREATE TABLE File (
	ID int NOT NULL ,
	FileName varchar (255) NULL ,
	FilePath varchar (255) NULL ,
	DlCnt int NULL ,
	UlCnt int NULL ,
	CreationDate datetime NULL ,
	ModifyDate datetime NULL ,
	LastDownloadDate datetime NULL ,
	OwnerID binary (8) NULL ,
	Permissions int NULL ,
	Comment varchar (255) NULL ,
	SessionID int NULL ,
	Fsys char (8) NULL ,
	FileSize int NULL ,
	UserPath varchar (255) NULL ,

	PRIMARY KEY(ID),
	KEY ix_file_name (FileName),
	KEY ix_file_path (FilePath),
	KEY ix_created (CreationDate),
	KEY ix_modified (ModifyDate)
);

CREATE TABLE FileAccess (
	ID int NOT NULL ,
	FileID int NOT NULL ,
	UserID binary (8) NOT NULL ,
	Action smallint NOT NULL ,
	CPS int NULL ,
	AccessDate datetime NULL ,
	SessionID int NULL ,

	PRIMARY KEY(ID),
	KEY ix_session (SessionID),
	KEY ix_file (FileID),
	KEY ix_user (UserID),
	KEY ix_what (AccessDate, Action)
);